unit Tastaturabfrageklasse;

{
Delphi-Implementation der API-Funktion GetKeyboardState
von Ulf Schaper, UlfSchaper@gmx.de
}

interface

uses Windows {kapselt alle Keyboardzugriffe}, Forms {Wegen Application.ProcessMessages};

type TTastaturAbfrageKeyTable = array[0..255] of boolean;

type TTastaturAbfrage = class
  protected
   LastState:TKeyboardState;
   function DoStrgAltGrCheck(Std:boolean):boolean;
  public
   procedure Update;
   function GetKeyPressed(Nr:byte):boolean;
   function GetKeysPressed:TTastaturAbfrageKeyTable;
   function GetNextPressedKey:byte;
  end;

implementation

procedure TTastaturAbfrage.Update;
begin
  GetKeyboardState(LastState);
end;

  // Returns the "pressed" info for a single key
function TTastaturAbfrage.GetKeyPressed(Nr:byte):boolean;
begin
  // If a key is pressed, GetKeyboardState will
  // return either 128 or 129, both numbers have
  // the 7th bit set, --> 2^7 = 128
  Result := Boolean(LastState[Nr] AND 128);
  if Nr = 162 then
    result := DoStrgAltGrCheck(result);
end;

  // Returns infos for all 256 keys
function TTastaturAbfrage.GetKeysPressed:TTastaturAbfrageKeyTable;
var i:integer;
begin
 for i := 0 to 255 do
  Result[i] := Boolean(LastState[i] AND 128);
  result[162] := DoStrgAltGrCheck(result[162]);
end;

function TTastaturAbfrage.DoStrgAltGrCheck(Std:boolean):boolean;
begin
result := std;
 if boolean(LastState[162] AND 128) then    // If Strg Left seems to be pressed
   if boolean(LastState[165] AND 128) then  // together with Alt Gr,
      result := false;                      // usually Strg Left is not really pressed.
end;

  // Waits till next Key is pressed and returns this key
function TTastaturAbfrage.GetNextPressedKey:byte;
var TempState:TKeyboardState;

 function Changes:integer;
 var i:integer;
 begin
 result := -1;
 for i := 255 downto 0 do
    if TempState[i] <> LastState[i] then
      begin
       result := i;
       Break;
      end;
 if result = 162 then                  // If Strg Left seems to be pressed
   if boolean(LastState[165] AND 128) then    // together with Alt Gr,
      result := 162;                   // usually only Alt Gr is really pressed.
 end;

begin
 Update;
 TempState := LastState;
 while Changes = -1 do
   begin
    Update;
    Application.ProcessMessages;
   end;
 result := Changes;
end;

end.
